// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
//var db = null;
angular.module('starter', ['ngCordova','ionic', 'starter.controllers','kritaFactories','kritaServices','kritaFilters','ngFx','ama', 'ngAnimate','pasvaz.bindonce','ngMessages'])

.run(function($ionicPlatform,$cordovaStatusbar) {
  $ionicPlatform.ready(function() {
   console.log("applicazione pronta ");
   
                       // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                       // for form inputs)
  if(window.cordova && window.cordova.plugins.Keyboard) {
   console.log("keyboard");
   cordova.plugins.Keyboard.hideKeyboardAccessoryBar(false);
 }
 
 if(window.StatusBar) {
                        console.log("statusbar"); 
                       // org.apache.cordova.statusbar required
                       window.StatusBar.styleDefault();
                       $cordovaStatusbar.hide(); 
                     }
                   });
})

.config(function($httpProvider){


  $httpProvider.interceptors.push(['$q', '$location', 'Session', function($q, $location,Session) {
            return {
                'request': function (config) {
                    config.headers = config.headers || {};
                    if(Session.token){
                      config.headers.Authorization = 'Bearer ' + Session.token;
                    }
                 //  }
                    return config;
                },
                'responseError': function(response) {
                  console.log("errore - inteceptors");
                  console.log(JSON.stringify(response));  
                    if(response.status === 401 || response.status === 403) {
                        $location.path('/app/login');
                    }
                    return $q.reject(response);
                } 
            };
        }]);
}).config(function($stateProvider, $urlRouterProvider) {
  $stateProvider
  .state('app', {
    cache: false, 
    url: "/app",
    abstract: true,
       templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })


  .state('app.login', {
    cache: false, 
    url: "/login",
    views: {
      'menuContent' :{
        templateUrl: "templates/login2.html",
        controller: 'LoginCtrl'
      }
    }
  })

  .state('app.prenota-taxi', {
    cache: false, 
    url: "/prenota-taxi",
    views: {
      'menuContent' :{
        templateUrl: "templates/prenota-taxi.html",
        controller: 'PrenotaTaxiCtrl'
      }
    }
  })

  .state('app.home', {
    cache: false, 
    url: "/home",
    views: {
      'menuContent' :{
        templateUrl: "templates/home.html",
        controller: 'HomeCtrl'
      }
    }
  })

  .state('app.attiva-notifiche', {
    cache: false, 
    url: "/attiva-notifiche",
    views: {
      'menuContent' :{
        templateUrl: "templates/centro-messaggi.html",
        controller: 'AttivaNotificheCtrl'
      }
    }
  })

 /* .state('app.documenti', {
    cache: false, 
    url: "/documenti",
    views: {
      'menuContent' :{
        templateUrl: "templates/documenti.html",
        controller: 'DocumentiCtrl'
      }
    }
  })

*/

  .state('app.geocoding', {
    cache: false, 
    url: "/geocoding",
    views: {
      'menuContent' :{
        templateUrl: "templates/mappa.html",
        controller: 'GeocodingCtrl'
      }
    }
  })


  .state('app.browse', {
    cache: false, 
    url: "/browse",
    views: {
      'menuContent' :{
        templateUrl: "templates/browse.html"
      }
    }
  })


  .state('app.questionario', {
    cache: false, 
    url: "/questionario",
    views: {
      'menuContent' :{
        templateUrl: "templates/questionario.html",
        controller: 'QuestionarioCtrl'
      }
    }
  })


    .state('app.saldoPunti', {
    cache: false, 
    url: "/saldo-punti",
    views: {
      'menuContent' :{
        templateUrl: "templates/saldo-punti.html",
        controller: 'SaldoPuntiCtrl'
      }
    }
  })


  .state('app.registration', {
    cache: false, 
    url: "/registration",
    views: {
      'menuContent' :{
        templateUrl: "templates/registration.html",
        controller: 'RegistrationCtrl'
      }
    }
  })

  .state('app.change-password', {
    cache: false, 
    url: "/change-password",
    views: {
      'menuContent' :{
        templateUrl: "templates/change-password.html",
        controller: 'ChangePasswordCtrl'
      }
    }
  })

  .state('app.reset-password', {
    cache: false, 
    url: "/reset-password",
    views: {
      'menuContent' :{
        templateUrl: "templates/reset-password.html",
        controller: 'ResetPasswordCtrl'
      }
    }
  })
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/login');
});

