angular.module('starter.controllers', [])

/********************************************************************************
* Controller principale dell'applicazione. Sovraintende al menu per adesso.
*
*
*********************************************************************************/
.controller('AppCtrl', function($ionicConfig,$scope,tdsvc,$cordovaPush,$amaDialogs,userMGR,$cordovaToast,$ionicPlatform,$cordovaGoogleMap,oauthToken,$ionicModal,$ionicLoading,$cordovaInAppBrowser,Booking, $ionicPopup,$ionicPopover,$timeout,$location,Phone,Session,AUTH_EVENTS) {
// Form data for the login modal
$scope.map = null;
$scope.loginData = {};
$scope.vista = {};

$scope.replaceAll = function replaceAll(str, find, replace) {
  return str.replace(new RegExp(find, 'g'), replace);
}


$scope.isEnabled = {'documenti':false,'crash':false,'speed':false,'garageVirtuale':false};

//$scope.isEnabled = {'documenti':true,'crash':true,'speed':true,'garageVirtuale':true};

$scope.logoutRequired = false;


console.log("AppCtrl %s",window.appVersion);
$scope.appVersion = window.appVersion;

$scope.ricordaPassword = function(email){
    console.log("hai richiesto la password via mail per il seguente utente " + JSON.stringify(email));

    userMGR.remind({'_id':email}).$promise.then(function (response) {
        $ionicLoading.hide();
        $amaDialogs.showAlert("richiesta password","Grazie, riceverai una mail con la password all'indirizzo specificato.");
    },   
    function(err){
        $ionicLoading.hide();
        console.log(JSON.stringify(err));
        var title = err.data.errorMajorCode;
        if(!title) title = 'errore di collegamento';
        var subj = err.data.errorMessage;
        if(!subj) subj ="LA570 non riesce a collegarsi. Controlla il tuo collegamento ad Internet e riprova.";
        $amaDialogs.showAlert(title,subj);
    });
}

$scope.currentUser = null;

$scope.setCurrentUser = function(user){
    $scope.currentUser = user;
}


$scope.isAuthenticated = function(){
    if($scope.currentUser) return true; else return false;
}

$scope.unIndirizzo = null;

$scope.setUnIndirizzo = function(indirizzo){
    $scope.unIndirizzo = indirizzo;
}

$scope.status = {};
$scope.status.carFinder = true;
$scope.called =false;

/* notifiche */
$scope.notifications = [];

if(window.localStorage['notifications']!=undefined){
    $scope.notifications = JSON.parse(window.localStorage['notifications']);
}

// call to register automatically upon device ready
/*  $ionicPlatform.ready(function (device) {
console.log("registrazione in corso");
$scope.register();
});
*/

// Register
$ionicPlatform.ready(function() {
    $scope.push = PushNotification.init({
        "android":{"senderID": "567219205234"},
        "ios":{"badge": "true","sound": "true","alert": "true"}
    });
    
    $scope.push.on('registration', function(data) {
        console.log("Register success " + JSON.stringify(data));
        $scope.regId = data.registrationId;
      //  $cordovaToast.showShortCenter('Registered for push notifications');

        $scope.registerDisabled=true;

        if (ionic.Platform.isIOS()) {
            storeDeviceToken("ios");
        }else
        if(ionic.Platform.isAndroid()){
            storeDeviceToken("android");
        }
    });


    $scope.push.on('notification', function(notification) {
        console.log("*******************************************"); 
        console.log(JSON.stringify(notification)); 
        console.log("*******************************************"); 

        // data.message,
        // data.title,
        // data.count,
        // data.sound,
        // data.image,
        // data.additionalData
        console.log(JSON.stringify(notification));
        if (ionic.Platform.isAndroid()) {
            handleAndroid(notification);
        }
        else if (ionic.Platform.isIOS()) {
            handleIOS(notification);
            $scope.$apply(function () {
                // aggiungi la notifica all'array
                $scope.notifications.push({'id':new Date().toLocaleString(),'message':notification.message,'status':status});
                window.localStorage['notifications'] = JSON.stringify($scope.notifications);
            })
        }
    });
});

// Android Notification Received Handler
function handleAndroid(notification) {
// ** NOTE: ** You could add code for when app is in foreground or not, or coming from coldstart here too
//             via the console fields as shown.
    console.log("In foreground " + notification.additionalData.foreground  + " Coldstart " + notification.coldstart);
    
    if (notification.message) {
        $cordovaToast.showShortCenter(notification.message);

        $scope.$apply(function () {
            var status = null;
            if(notification.message.match('annullata'))
                var status = "annullata"
            if(notification.message.match('inoltrata'))
                var status = "inoltrata"
            if(notification.message.match('accettata'))
                var status = "accettata"
            if(notification.message.match('rifiutata'))
                var status = "rifiutata"
            if(notification.message.match('prenotata'))
                var status = "prenotata"
            var msg = {'id':new Date().toLocaleString(),'message':notification.message,'status':status};
                $scope.notifications.push(msg);
                window.localStorage['notifications'] = JSON.stringify($scope.notifications);
        })
    }


    $scope.$apply(function () {
        if(notification.additionalData.foreground===false){
            console.log(notification.additionalData.foreground); 
            $timeout(function(){
                $scope.go('/app/attiva-notifiche');
            },1500);
        }else{
            console.log(notification.additionalData.foreground); 
        }
    }); 
}

// IOS Notification Received Handler
function handleIOS(notification) {
// The app was already open but we'll still show the alert and sound the tone received this way. If you didn't check
// for foreground here it would make a sound twice, once when received in background and upon opening it from clicking
// the notification when this code runs (weird).

if(notification.additionalData.foreground){
// Play custom audio if a sound specified.
    if (notification.sound) {
        var mediaSrc = $cordovaMedia.newMedia(notification.sound);
        mediaSrc.promise.then($cordovaMedia.play(mediaSrc.media));
    }

    if (notification.message) {
    $cordovaToast.showShortCenter(notification.message);
    }

    if (notification.badge) {
        $scope.push.setApplicationIconBadgeNumber(function (result) {
            console.log("Set badge success " + result)
        }, function (err) {
            console.log("Set badge error " + err)
        },notification.count);
    }
}
// Otherwise it was received in the background and reopened from the push notification. Badge is automatically cleared
// in this case. You probably wouldn't be displaying anything at this point, this is here to show that you can process
// the data in this situation.
else {
        if (notification.sound) {
            var mediaSrc = $cordovaMedia.newMedia(notification.sound);
            mediaSrc.promise.then($cordovaMedia.play(mediaSrc.media));
        }

        if (notification.message) {
        $cordovaToast.showShortCenter(notification.message);
        }

        if (notification.badge) {
            $scope.push.setApplicationIconBadgeNumber(function (result) {
                console.log("Set badge success " + result)
            }, function (err) {
                console.log("Set badge error " + err)
            },notification.count);
        }

        $scope.push.finish(function() {
            console.log("processing of push data is finished");
        });
    }
}




// Stores the device token in a db using node-pushserver (running locally in this case)
//
// type:  Platform type (ios, android etc)
function storeDeviceToken(type) {
// Create a random userid to store with it
if(!$scope.currentUser.username){
    console.log("impossibile registrarsi. Stranamente username " + $scope.currentUser.username + " non è definito");
}
else{
var user ={ platform: type, registrationID: $scope.regId, user:$scope.currentUser.username}; //{ user: 'user' + Math.floor((Math.random() * 10000000) + 1), platform: type, registrationID: $scope.regId };
console.log("Post token for registered device with data " + JSON.stringify(user));
}



tdsvc.registrationID(user,
    function(res){
        if(res.success){
            console.log(JSON.stringify(res));
            console.log("Token stored, device is successfully subscribed to receive push notifications.");
            if($scope.refreshToken)
                $scope.refreshToken();
        }
        else{
            console.log(JSON.stringify(res));
        }
    },function(err){
// console.log(JSON.stringify(err));
    console.log("Error storing device token." + JSON.stringify(err.data) + " err.status:" + err.status)
});

/*   $http.post('http://192.168.1.176:8080/registrationID', JSON.stringify(user))
.success(function (data, status) {
console.log("Token stored, device is successfully subscribed to receive push notifications.");
})
.error(function (data, status) {
console.log("Error storing device token." + data + " " + status)
}
); */
}

// Removes the device token from the db via node-pushserver API unsubscribe (running locally in this case).
// If you registered the same device with different userids, *ALL* will be removed. (It's recommended to register each
// time the app opens which this currently does. However in many cases you will always receive the same device token as
// previously so multiple userids will be created with the same token unless you add code to check).
function removeDeviceToken() {
    var tkn = {"token": $scope.regId};
    $http.post('http://192.168.1.176:8080/registrationID', JSON.stringify(tkn))
    .success(function (data, status) {
        console.log("Token removed, device is successfully unsubscribed and will not receive push notifications.");
    })
    .error(function (data, status) {
        console.log("Error removing device token." + data + " " + status)
    }
    );
}

// Unregister - Unregister your device token from APNS or GCM
// Not recommended:  See http://developer.android.com/google/gcm/adv.html#unreg-why
//                   and https://developer.apple.com/library/ios/documentation/UIKit/Reference/UIApplication_Class/index.html#//apple_ref/occ/instm/UIApplication/unregisterForRemoteNotifications
//
// ** Instead, just remove the device token from your db and stop sending notifications **
$scope.unregister = function () {
    console.log("Unregister called");
    removeDeviceToken();
    $scope.registerDisabled=false;
//need to define options here, not sure what that needs to be but this is not recommended anyway
//        $cordovaPush.unregister(options).then(function(result) {
//            console.log("Unregister success " + result);//
//        }, function(err) {
//            console.log("Unregister error " + err)
//        });
}

/* notifiche end */
$scope.rememberMe = function(credentials){
    window.localStorage['credentials'] = JSON.stringify(credentials);
}

$scope.forgetMe = function(){
    window.localStorage.removeItem('credentials');
}


$scope.callTo = function(url){
    var options = {
        location: 'no',
        clearcache: 'yes',
        toolbar: 'no'
    };
    console.log("sto per chiamare " + url);
    $cordovaInAppBrowser.open(url, '_system', options).then(function(event) {
        console.log("documento aperto con successo");
    })
    .catch(function(event) {
        console.log("errore durante apertura documento");
    });
}

var _manageExit = function(){
    $scope.showConfirm('conferma uscita',"Vuoi davvero uscire dall'applicazione?" ,function(res) {
        if(res){
            $scope.called = false;
            navigator.app.exitApp();
        }else{
            $scope.called = false;
        }
    },'<span class="ion-ios-checkmark-outline balanced"></span>','<span class="ion-ios-close-outline"></span>');
}
$scope.manageExit = function(){
    if(!$scope.called){
        $scope.called=true;
        _manageExit();
    }
    else
        return;
}



$scope.context = null;

$scope.setContext = function(ctx){
    $scope.context = ctx;
}


$scope.refreshContext = function(){
    console.log("mi accingo a rinfrescare il contesto");
    tdsvc.context().$promise.then(function (context) {
        console.log("ricevuto il contesto");
        $scope.setContext(context);
    },
    function(err){
        console.log("errore durante il context");
        console.log(JSON.stringify(err));
    });
}

$scope.showAlert = function(title,template,onEnd) {
// var okLbl ='<span class="ion-ios-checkmark-outline balanced"></span>';
var alertPopup = $ionicPopup.alert({
    title: title,
    template: template
});
alertPopup.then(function(res) {
    if(onEnd) onEnd(res);
});
};

// A confirm dialog
$scope.showConfirm = function(title,template,onAction,okLbl,cancLbl) {
    var confirmPopup;
    var btCancel = null;
    var btOk = null;
    var buttons = [];
    if(cancLbl){
        btCancel =  {
            text: cancLbl,
            type: 'button-default',
            onTap: function(e) {
                return false;      }
            };
            buttons.push(btCancel);
        }

        if(okLbl){
            btOk = {
                text: okLbl,
                type: 'button-positive',
                onTap: function(e) {
                    return true;
                }
            }
            buttons.push(btOk);
        }

        if(cancLbl && okLbl){
            confirmPopup = $ionicPopup.confirm({
                title: title,
                template: template,
                buttons:buttons
            });

        }else{
            confirmPopup = $ionicPopup.confirm({
                title: title,
                template: template
            });
        }

        confirmPopup.then(onAction);
    };

    $scope.$on(AUTH_EVENTS.loginFailed,function(event,err){
console.log("Autorizzazione Negata"); //, JSON.stringify (err));
    console.log(JSON.stringify(err));
// gestire gli eventi relativi ad errori tipo 404, 401, 403 etc
/*        if(err.errorCode===5122){
$amaDialogs.showAlert("Errore di Collegamento","Impossibile collegarsi al server. Controlla la tua connessione ad Internet");
}
*/
if(err){
    if(err.errorCode == 5122)
        $scope.showAlert("Autorizzazione negata","Nome utente o password non validi.");
    else
        $scope.showAlert("Autorizzazione negata",err.status);
}
});

    $scope.$on(AUTH_EVENTS.notAuthenticated, function(){
        $scope.showAlert("EVENTO","Non Autenticato");

    });
    $scope.$on(AUTH_EVENTS.sessionTimeout, function(){
        var rt = Session.ad.refreshToken.value;
        oauthToken.renew({grant_type:'refresh_token',client_id:'fca-client',client_secret:'fca-client-secret',refresh_token:rt})
        .$promise.then(function (authData) {
            console.log("ho rinnovato il token");
            Session.refresh(authData);
        },
        function(err){
            console.log("errore durante il rinnovo del token");
            console.log(err);
        });
    });

    $scope.$on(AUTH_EVENTS.loginSuccess, function(event,auth){
        console.log("******************");
        console.log(JSON.stringify(auth));
        console.log("******************");

        /*
        $ionicPlatform.ready(function (device) {
            console.log("registrazione in corso");
            $scope.register();
        });
        */

    });





    $scope.logout = function(){
        console.log("richiesto logout");
        $scope.forgetMe();
        $scope.logoutRequired = true;
        Session.destroy();
        $scope.go('/app/login');
    }

    $scope.elementHeight=function(id){
        console.log($scope.contentHeight);
        var prodDetElement = document.getElementById(id);
        var proddet = prodDetElement.offsetHeight;
        var proddetb = document.getElementById('product-details-buttons').offsetHeight;
        proddetbm = document.getElementById('product-details-button-minus').offsetHeight;
        $scope.imageHeight2 = $scope.contentHeight - (proddet + proddetb + proddetbm + 20 + 30);
        $scope.imageWidth2 =  prodDetElement.offsetWidth;
        console.log("imageHeight:%s dettagli-prodotto:%s bottoni:%s width:%s",$scope.imageHeight2, proddet, proddetb+proddetbm,$scope.imageWidth2);


        return $scope.contentHeight - proddet;
    }



/* menu opzioni tipico di android. su questa app non dovrebbe essere necessario.
$ionicPopover.fromTemplateUrl('templates/dlg/options.html', {
scope: $scope,
}).then(function(popover) {
console.log("ho creato il popover");
console.log(popover);
$scope.optMenu = popover;
});


$scope.openOptMenu = function($event,queryString) {
console.log("ciao");
$scope.optMenu.show($event);
};

$scope.closeOptMenu = function() {
$scope.optMenu.hide();
};

$scope.$on('$destroy', function() {
console.log("destroy");
$scope.optMenu.remove();
});

$scope.$on('popover.hidden', function() {
// Execute action
});
$scope.$on('popover.removed', function() {
// Execute action
});


*/


var nb = document.getElementsByClassName('nav-bar');
if(!nb[0])
    nb = document.getElementsByClassName('bar-header');

$scope.boOffset = 20;

if(nb[0]){
    if(ionic.Platform.isIOS()) $scope.boOffset = 0;
$scope.contentHeight = (window.innerHeight - nb[0].offsetHeight) -$scope.boOffset; // -44;
$scope.contentHeightpx  = $scope.contentHeight  + 'px';
$scope.contentWidth = window.innerWidth;
$scope.imageHeight = $scope.contentHeight - 66; //40;
$scope.imageHeight2 = 415;
$scope.imageWidth2 = 497;

$scope.imgBtnWidth = Math.round(($scope.contentWidth-20)/2);
$scope.imgBtnHeight = Math.round(($scope.contentHeight) /3);
$scope.imgLblTop = Math.round(($scope.imgBtnHeight) - 39);


console.log("contentHeight: %s",$scope.contentHeight);
console.log("contentWidth: %s",$scope.contentWidth);
console.log("imageHeight: %s", $scope.imageHeight);
console.log("imgBtnHeight: %s", $scope.imgBtnHeight);
console.log("imgBtnWidth: %s", $scope.imgBtnWidth);


}


Session.piattaforma = ionic.Platform.platform();
console.log("Piattaforma  " +Session.piattaforma);

$scope.go = function(path,direction){
    console.log("*************************");
    console.log($location.path());
    console.log(path);
    console.log("*************************");
    $location.path(path);
};

})


/*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
************* TARGA DRIVE - TARGA DRIVE - TARGA DRIVE - TARGA DRIVE - TARGA DRIVE ***************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************
*************************************************************************************************/


.controller('LoginCtrl', function($scope,$cordovaAppVersion,$ionicPlatform,$ionicLoading,$timeout,$amaDialogs,$rootScope,Phone,AuthService, Session, $stateParams,Booking,AUTH_EVENTS) {
    $scope.piattaforma = ionic.Platform.platform() +" " + !!(window.cordova) +  " " + ionic.Platform.isWebView() + " " + ionic.Platform.version();


// 'Attivare notifiche per <select ng-model="reqpay.duration" ng-options="o.id as o.nome for o in opzioniDurata"></select> ore<br> oltre i <select ng-model="reqpay.speed" ng-options="os.id as os.nome for os in opzioniVel"></select> Km/h?'
    $scope.reqpay = {email:null}; 

    $scope.pwdDimenticataDlg = function(){
        $amaDialogs.showConfirm("Recupera Password",
            "<p>Inserisci il tuo indirizzo email per ricevere una mail con la nuova password?</p><input name='email' type='email' ng-model='reqpay.email'>"
            ,function(res){
            if(res){
                console.log($scope.reqpay.email); 
                 $scope.ricordaPassword($scope.reqpay.email);
            }else{
        //        console.log("ripeti registrazione");
            }
        },"invia","annulla",$scope); // fine showConfirm
    }

    $scope.init = function(){
        var logo = document.getElementById('logo');
        console.log('logo height:',logo.offsetHeight);

// var motto = document.getElementById('motto');
// console.log('motto height:',motto.offsetHeight);

console.log('content Height:',$scope.contentHeight);

//  $scope.lfHeight = (($scope.contentHeight - motto.offsetHeight) - logo.offsetHeight);

$scope.lfHeight = (($scope.contentHeight) - logo.offsetHeight);
console.log("login form height:",$scope.lfHeight);
}

$timeout(function(){
    console.log("init questo init?");

    var logo = document.getElementById('logo');
    console.log('logo height:',logo.offsetHeight);

    console.log('content Height:',$scope.contentHeight);
    console.log("login form height:",$scope.lfHeight);

    if(window.localStorage['credentials']!=undefined){
        $scope.credentials = JSON.parse(window.localStorage['credentials']);
        console.log(JSON.stringify($scope.credentials.username));
        $scope.doLogin($scope.credentials);
    }else{
        $scope.visible = true;
    }
},500);


$scope.visible =false;

$rootScope.$on('$viewContentLoading',
    function(event, viewConfig){
        console.log("contentLoading");
    });

$scope.$on('$viewContentLoaded',
    function(event){
        console.log("evento");
// event.preventDefault();
});


if(window.localStorage['credentials']!=undefined){
    $scope.credentials = JSON.parse(window.localStorage['credentials']);
    console.log(JSON.stringify($scope.credentials.username));
}

// funzione doLogin di loginCTRL
$scope.doLogin = function(credentials){
// credentials.username = credentials.username.toUpperCase();

if(!credentials){
    $rootScope.$broadcast(AUTH_EVENTS.loginFailed,{'status':'error',errorCode:'5123'});
    return;
}else{
    if(!credentials.username){
        $rootScope.$broadcast(AUTH_EVENTS.loginFailed,{'status':'error',errorCode:'5124'});
        console.log("username non specificato o non valido");
    }else{
        if(!credentials.password){
            $rootScope.$broadcast(AUTH_EVENTS.loginFailed,{'status':'error',errorCode:'5125'});
            console.log("password non specificata o non valida");
        }
    }
}

$scope.visible = false;



AuthService.login(credentials).then(function (auth) {
    console.log("LoginCtrl: autenticazione riuscita");
    $rootScope.$broadcast(AUTH_EVENTS.loginSuccess,auth);
    credentials.auth = auth;
    $scope.rememberMe(credentials);
    $scope.setCurrentUser(credentials);
    $timeout(function(){
//$ionicLoading.hide();
//  $scope.visible = true;
$scope.go("/app/prenota-taxi");
}, 300);

}, function (err) {
    $timeout(function(){
        $scope.visible = true;
        console.log("prima di geneare l'evento");
        console.log(JSON.stringify(err));
        $rootScope.$broadcast(AUTH_EVENTS.loginFailed,err);
    }, 300);

});
}
})
/********************************************************************************************/


/*************************************************************************************************
* Il contoller della pagina di registration
*
*
*
*************************************************************************************************/

.controller('RegistrationCtrl', function($scope,AUTH_EVENTS,$timeout,AuthService,$ionicLoading,$ionicPlatform,userMGR,$rootScope,$stateParams,$amaDialogs) {
    console.log("sei nel controller registration");


// funzione doLogin di registrationCTRL
$scope.doLogin = function(credentials){
// credentials.username = credentials.username.toUpperCase();

$scope.visible = false;


AuthService.login(credentials).then(function (auth) {
    console.log("LoginCtrl: autenticazione riuscita");
    $rootScope.$broadcast(AUTH_EVENTS.loginSuccess,auth);
    credentials.auth = auth;
    $scope.rememberMe(credentials);
    $scope.setCurrentUser(credentials);
    $timeout(function(){
        $scope.go("/app/prenota-taxi");
    }, 300);

}, function (err) {
    $timeout(function(){
        $scope.visible = true;
        console.log("prima di geneare l'evento");
        console.log(JSON.stringify(err));
        $rootScope.$broadcast(AUTH_EVENTS.loginFailed,err);
    }, 300);

});
}


$scope.doRegister = function(dati){
    var ok = true;



    if(!dati){
        ok=false;
        $amaDialogs.showAlert("Attenzione","Per completare la registrazione sono necessarie tutte le informazioni richieste");
        return;
    }

    if(!dati.nome || !dati.cognome || !dati.telefono || !dati.email){
        ok=false;
        $amaDialogs.showAlert("Attenzione","Per completare la registrazione sono necessarie tutte le informazioni richieste");
        return;
    }
    if(!dati.accept){
        ok=false;
        $amaDialogs.showAlert("Attenzione","E' necessario accettare la politica della privacy per proseguire con la registrazione");
        return;
    }

    $ionicLoading.show({
        template: '<ion-spinner></ion-spinner>',
        animation: 'fade-in',
        showBackdrop: false,
        maxWidth: 200,
        showDelay: 500
    });

userMGR.save({//'token':$scope.currentUser.token,
    'body':dati}).$promise.then(function (projectResponse) {
        $ionicLoading.hide();
        if(projectResponse.status=='error'){
            if(projectResponse.data.code==11000){
                $amaDialogs.showConfirm("Utente già registrato","L'utente risulta già registrato. Vuoi ricevere una mail con la password?",function(res){
                    if(res){
                        $scope.ricordaPassword(dati.email);
                         $scope.go('/app/login');
                    }else{
// non voglio ricevere la mail con la password, quindi ripeto la registrazione.
console.log("ripeti registrazione");
}
},"sì","no"); // fine showConfirm
} // fine if projectResponse.data
console.log(projectResponse.data);
} // fine if project response
else
    if(projectResponse.status=='success'){
        console.log("registrazione avvenuta con successo");
        $amaDialogs.showAlert("Registrazione Avvenuta","La registrazione è stata completata con successo. Riceverai una email con le credenziali di accesso.",function(res){
            $scope.doLogin({'username':dati.email,'password':'first_registrtion'});
        });
    }
},
function(err){
    console.log(err);
    $timeout(function(){
        $ionicLoading.hide();
        console.log(JSON.stringify(err));
        var title = title = 'errore di collegamento';
        var subj ="Impossibile completare la registrazione per un problema con il collegamento ad Internet.";
        $amaDialogs.showAlert(title,subj);
    }, 300);
});

}







})
/********************************************************************************************/



/*************************************************************************************************
* Il contoller della pagina di resetpassword
*
*
*
*************************************************************************************************/

.controller('ResetPasswordCtrl', function($scope,$ionicPlatform, $rootScope,Phone,AuthService, Session, $stateParams,Booking,AUTH_EVENTS){
    console.log("sei nel controller reset password");

})
/********************************************************************************************/




/*************************************************************************************************
* Il contoller della pagina di changePassword
*
*
*
*************************************************************************************************/

.controller('ChangePasswordCtrl', function($scope,$ionicPlatform, $rootScope,Phone,AuthService, Session, $stateParams,Booking,AUTH_EVENTS){
    console.log("sei nel controller change password");


})
/********************************************************************************************/

/*************************************************************************************************
* Il contoller della pagina di prenota-taxi
*
*
*
*************************************************************************************************/

.controller('PrenotaTaxiCtrl', function($scope,$filter,reservationMGR,$cordovaGeolocation,$ionicPlatform,$amaDialogs,$rootScope,$timeout,$ionicLoading,$stateParams){
    console.log("sei nel controller prenota taxi");


    $scope.mostraNascondiRichieste = function(){
//    var altezzaRichieste = document.getElementById('richieste').offsetHeight;
//    if($scope.corsa.richieste){
//      console.log("lo stato è attivo " + altezzaRichieste);
//    }
//    else
//      console.log("disattivo"  + altezzaRichieste);
}

$scope.showMappa = function(){
    $scope.go('/app/geocoding');
}

$scope.geocoding = function(){
    console.log("geocoding");
    $ionicLoading.show({
        template: '<ion-spinner></ion-spinner>',
        animation: 'fade-in',
        showBackdrop: false,
        maxWidth: 200,
        showDelay: 500
    });

    $scope.yourLocation = {'position':{'lat':null,'lng':null}};
    var posOptions = {timeout: 10000, enableHighAccuracy: true};

    var onGetPositionSuccess = function (position) {
        $scope.yourLocation.position = {'lat':position.coords.latitude,'lng':position.coords.longitude};
        $scope.corsa.gps = JSON.stringify($scope.yourLocation.position);
        
        console.log(JSON.stringify($scope.yourLocation.position)); 

        // richiedo il reverse geocoding, cioé l'indirizzo in prossimità delle coordinate
        if(typeof plugin=='undefined') $ionicLoading.hide();
        else
        {
            $timeout(function(){$scope.revGeoCoding($scope.yourLocation)},2000);
        }
    }; 

    var onGetPositionError = function(err){
        console.log("errore nel tentativo di ottenere la posizione corrente");
        console.log(JSON.stringify(err));
        $amaDialogs.showAlert("Servizi per la posizione disattivati","La570 ha bisogno di accedere alla tua posizione. Attiva i servizi di localizzazione nelle impostazioni del dispositivo."); 

        $ionicLoading.hide();
    };

    $cordovaGeolocation.getCurrentPosition(posOptions).then(onGetPositionSuccess,onGetPositionError);
}

$scope.revGeoCoding = function(location){
    plugin.google.maps.Geocoder.geocode(location, function(results) {
        if (results.length) {
            var result = results[0];
                                        console.log(results); 
            var position = result.position;

            $scope.corsa.indirizzoSalita = [
            result.subThoroughfare || "",
            result.thoroughfare || "",
            result.locality || "",
            result.adminArea || "",
            result.postalCode || "",
            result.country || ""].join(", ");
                                        
            console.log($scope.corsa.indirizzoSalita);

            $scope.corsa.provincia = result.subAdminArea;
            $scope.corsa.comune = result.locality;
            $scope.corsa.localita = result.locality;
            $scope.corsa.indirizzo = result.thoroughfare + ' ' +  result.subThoroughfare;
            $scope.corsa.cap = result.postalCode;
            $scope.corsa.numeroCivico = result.thoroughfare;
            $scope.corsa.nazione = result.country;
                                        
            console.log(JSON.stringify(position));
            console.log(JSON.stringify($scope.corsa.indirizzoSalita));
                                        console.log("indirizzo:",$scope.corsa.indirizzo);
                                        console.log("località:",$scope.corsa.localita);
                                        console.log("comune:",$scope.corsa.comune);
                                        console.log("provincia:",$scope.corsa.provincia);
                                        console.log("nazione:",result.country);
                                        console.log("cap:",$scope.corsa.cap);

                                        console.log(result);
                                        
            $scope.corsa.indirizzoSalita = "{{indirizzo}} - {{cap}} {{comune}} {{provincia}}"; 

            $scope.corsa.indirizzoSalita = $scope.corsa.indirizzoSalita
            .replace("{{indirizzo}}",$scope.corsa.indirizzo)
            .replace("{{cap}}",$scope.corsa.cap)
            .replace("{{comune}}",$scope.corsa.comune)
            .replace("{{provincia}}",'('+$scope.corsa.provincia+')');  

            $scope.corsa.indirizzoSalita = $scope.replaceAll($scope.corsa.indirizzoSalita,'undefined',''); 
            $scope.corsa.indirizzoSalita = $scope.replaceAll($scope.corsa.indirizzoSalita,'[(][)]','');
            $scope.corsa.indirizzoSalita = $scope.replaceAll($scope.corsa.indirizzoSalita,'Provincia di ','');
            $scope.corsa.indirizzoSalita = $scope.replaceAll($scope.corsa.indirizzoSalita,'\ +',' ');


            $ionicLoading.hide();

        } else {
//$scope.showAlert("Errore GeoCodifica", "Impossibile risalire all'indirizzo dell'auto");
console.log("indirizzo non trovato");
$ionicLoading.hide();
}
});
}

//var ora = $filter("date")(Date.now(), 'yyyy-MM-dd  HH:mm');
var today = new Date();
var day = today.getDate();
var month = today.getMonth();
var year = today.getFullYear();
var hours = today.getHours();
var minutes = today.getMinutes();
var data = new Date(year,month,day,hours,minutes);

$scope.corsa = {
    data:data,
    ora:data
}
            
      


$scope.corsa.utente = {'nome':$scope.currentUser.auth.profilo.nome,
'cognome':$scope.currentUser.auth.profilo.cognome,
'email':$scope.currentUser.auth.profilo.username,
'telefono':$scope.currentUser.auth.profilo.telefono,
'codicefiscale':$scope.currentUser.auth.profilo.codicefiscale};

$scope.corsa.richieste = $scope.currentUser.auth.profilo.richieste;

$scope.corsa.equipaggiamento = $scope.currentUser.auth.profilo.equipaggiamento;


console.log(JSON.stringify($scope.corsa));





if(!$scope.unIndirizzo)
    $scope.geocoding()
else
    $scope.corsa.indirizzoSalita = $scope.unIndirizzo;


$scope.prenota = function(corsa) {
    $ionicLoading.show({
        template: '<ion-spinner></ion-spinner>',
        animation: 'fade-in',
        showBackdrop: false,
        maxWidth: 200,
        showDelay: 500
    });

reservationMGR.save({//'token':$scope.currentUser.token,
    'body':corsa}).$promise.then(function (projectResponse) {
        if(projectResponse.status=='error'){
            if(projectResponse.data.code==11000){
                $amaDialogs.showConfirm("Richiesta già inoltrata","La richiesta è già inoltrata",function(res){
                    if(res){
//$scope.ricordaPassword();
}
},"sì","no");
            }else{
                $amaDialogs.showAlert("richiesta fallita","Impossibile completare la richiesta.");
            }
            console.log(projectResponse.data);
        }
        $timeout(function(){
            $ionicLoading.hide();
//  + projectResponse.resnum + " "
$amaDialogs.showAlert("TAXIgo","Richiesta di prentazione inoltrata",function(res){
    console.log(JSON.stringify($scope.currentUser.auth.profilo));
    console.log(JSON.stringify(corsa));
    $scope.go('/app/saldo-punti');
});

}, 2500);
    },
    function(err){
        console.log("errorissimo");
        console.log(err);
        $timeout(function(){

            $ionicLoading.hide();
            console.log(JSON.stringify(err));

            var title = err.data.errorMajorCode;
            if(!title) title = 'errore di collegamento';
            var subj = err.data.errorMessage;
            if(!subj) subj ="Impossibile completare la richiesta per un problema di collegamento.";

            $amaDialogs.showAlert(title,subj);
        }, 300);
    });



}

})
/********************************************************************************************/

/*************************************************************************************************
* Il contoller della pagina di Questionario
*
*
*
*************************************************************************************************/

.controller('QuestionarioCtrl', function($scope,$amaDialogs,$ionicPlatform, $rootScope,Phone,AuthService, Session, $stateParams,Booking,AUTH_EVENTS){
    $scope.giudizio = {
        conforto:0,
        pulizia:0,
        puntuale:0,
        guida:0
    }

    $scope.inviaGiudizio = function(giudizio){
        console.log("Il giudizio è " + JSON.stringify($scope.giudizio));
        $amaDialogs.showAlert("TaxiGo","Grazie, il tuo giudizio è stato memorizzato.",function(res){
            $scope.go("/app/saldo-punti");
        })

    }
})
/********************************************************************************************/


/*************************************************************************************************
* Il contoller della pagina di Saldo Punti
*
*
*
*************************************************************************************************/

.controller('SaldoPuntiCtrl', function($scope,$ionicPlatform, $rootScope,Phone,AuthService, Session, $stateParams,Booking,AUTH_EVENTS){
    console.log("sei nel controller del Saldo Punti");




})
/********************************************************************************************/


/*************************************************************************************************
* Il contoller della mappa del clienti
*
*angular.module('ngCordova.plugins.googleMap', [])

.factory('$cordovaGoogleMap', ['$q', function($q) {
*
*************************************************************************************************/

.controller('MappaClientiCtrl', function($scope, $timeout, $cordovaGoogleMap,Phone) {

    $scope.$on('plugin.google.maps.event.MAP_READY', function (event, data) {
        console.log(data);
console.log("pappa pronta"); // 'Data to send'
});

    $scope.$on('MAP_READY', function (event, data) {
console.log(data); // 'Data to send'
console.log("mappa pronta");
});

    $scope.closeMap = function(){
        $cordovaGoogleMap.cleanup();
    }


    $scope.createMap = function() {
        console.log("sono nel controller");
        var map = $cordovaGoogleMap.getMap({
            'controls': {
                'compass': true,
                'myLocationButton': true,
                'indoorPicker': true,
                'zoom': true
            },
            'gestures': {
                'scroll': true,
                'tilt': false,
                'rotate': true,
                'zoom': true
            },
            'camera': {
                'latLng': {"lat":40.8071741,"lng":14.5418959},
                'zoom': 4,
                'bearing': 0
            }
        });

        map.showDialog(true);
        map.setDebuggable(true);

        map.addEventListener(plugin.google.maps.event.MAP_READY, function() {
            console.log("ok dovrei caricare i markers per %s", $scope.azienda.id);
            Phone.getMarkers($scope.azienda,$scope.currentUser.ruolo).then(function(markers){
                _.each(markers,function(marker){
                    marker.snippet = "tocca per le indicazioni stradali!";
                    marker.infoClick = function(ma){
                        console.log("indicazioni stradali richieste");
                        console.log(ma); 
                    }
                    map.addMarker(marker);
                });                                                
            }), function(err) {
                console.error('Unable to create the map', err);
                alert('Unable to create the map');
            };
        });

        map.addEventListener(plugin.google.maps.event.MAP_CLOSE, function() {
            console.log("The map dialog is closed");
            map.remove();
        });
    }

    $scope.$parent.$on('$stateChangeStart', 
        function(event, toState, toParams, fromState, fromParams){ 
// event.preventDefault(); 
if($cordovaGoogleMap.isMapLoaded())
    $cordovaGoogleMap.setVisible(false);
// $cordovaGoogleMap.cleanup();
})

}) 

/*************************************************************************************************/



/*************************************************************************************************
* Controller della pagina home
* 
*
*
*************************************************************************************************/

.controller('HomeCtrl', function($ionicLoading,$scope,$cordovaInAppBrowser,$timeout, $amaDialogs,$ionicPlatform, $rootScope,Session,$stateParams,userMGR) {
    console.log("entrato in homeCtrl"); 
    $scope.profilo = $scope.currentUser.auth.profilo;  

    $scope.aggiorna = function(dati){
        $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>',
            animation: 'fade-in',
            showBackdrop: false,
            maxWidth: 200,
            showDelay: 500  
        });  

        userMGR.set(dati).$promise.then(function (response) {
            $timeout(function(){
                $ionicLoading.hide();        
            },1500); 
        },
        function(err){
            $ionicLoading.hide();
            console.log(JSON.stringify(err)); 
            var title = err.data.errorMajorCode; 
            if(!title) title = 'errore di collegamento';
            var subj = err.data.errorMessage; 
            if(!subj) subj ="Impossibile aggiornare il profilo utente per problemi di collegamento."; 

            $amaDialogs.showAlert(title,subj);
        });  

    }

})

/********************************************************************************************/


/*************************************************************************************************
* Controller della pagina attivaNotificheCtrl
* 
*
*
*************************************************************************************************/

.controller('AttivaNotificheCtrl', function($scope,$timeout,$ionicLoading,$amaDialogs,reservationMGR,$ionicPlatform, $rootScope,Phone,AuthService,Session,$stateParams,Booking,AUTH_EVENTS) {
    console.log("entrato in attivaNotificheCtrl"); 

    $scope.imgBtnWidth = Math.round(($scope.contentWidth-20)/2);
    $scope.imgBtnHeight = Math.round(($scope.contentHeight-20) /3);
    $scope.imgLblTop = Math.round(($scope.imgBtnHeight) - 39); 


    console.log("contentHeight: %s",$scope.contentHeight); 
    console.log("contentWidth: %s",$scope.contentWidth); 
    console.log("imageHeight: %s", $scope.imageHeight); 
    console.log("imgBtnHeight: %s", $scope.imgBtnHeight); 
    console.log("imgBtnWidth: %s", $scope.imgBtnWidth); 


    var onRsvMgrSuccess = function (projectResponse) {
        console.log(JSON.stringify(projectResponse.data));
        $scope.reservations =  $scope.notifications;
         //projectResponse.data; 
         console.log($scope.reservations); 

        if(projectResponse.status=='error'){
            $amaDialogs.showAlert("richiesta fallita","Impossibile completare la richiesta.");  
        }

        $timeout(function(){
            $ionicLoading.hide();
        }, 1500); 
    }; 

    var onRsvMgrError = function(err){
        console.log("errorissimo"); 
        console.log(err); 
        $timeout(function(){
            $ionicLoading.hide();
            console.log(JSON.stringify(err)); 

            var title = err.data.errorMajorCode; 
            if(!title) title = 'errore di collegamento';
            var subj = err.data.errorMessage; 
            if(!subj) subj ="Impossibile completare la richiesta per un problema di collegamento."; 

            $amaDialogs.showAlert(title,subj);
        }, 300);
    }; 

//reservationMGR.list({'id':$scope.currentUser.username}).$promise.then(onRsvMgrSuccess,onRsvMgrError); 
    
    $scope.reservations =  $scope.notifications;




})

/********************************************************************************************/



/*************************************************************************************************
* Controller della pagina Geocoding
* 
*
*
*************************************************************************************************/

.controller('GeocodingCtrl', function($scope,$cordovaAppVersion,$amaDialogs,$cordovaGeolocation,$ionicPlatform,$cordovaInAppBrowser, $rootScope,Phone,AuthService,Session,$stateParams,Booking) {


    $scope.reverse = function(position){
        plugin.google.maps.Geocoder.geocode(position, function(results) {
            if (results.length) {
                var result = results[0];
                var position = result.position; 
                var address = [
                result.subThoroughfare || "",
                result.thoroughfare || "",
                result.locality || "",
                result.adminArea || "",
                result.postalCode || "",
                result.country || ""].join(", ");


                $scope.setUnIndirizzo(address); 
                $scope.marker.title=address; 
                console.log(address); 
                $scope.map.setClickable(false);    
                $amaDialogs.showConfirm("Nuovo Indirizzo","Usare l'indirizzo " + address + " come nuovo punto di partenza?",function(res){
                    if(res){
                        $scope.map.setClickable(true);    
                        console.log("si"); 
                        $scope.setUnIndirizzo(address); 
                        $scope.go('/app/prenota-taxi'); 
                    }else{
                        $scope.map.setClickable(true);    
                        console.log("no"); 
                    }
                },"si","no");


            } else {
//$amaDialogs.showAlert("Errore GeoCodifica", "Impossibile risalire all'indirizzo dell'auto"); 
console.log("Not found");
}
}); 
}


$scope.contentHeight = $scope.contentHeight + $scope.boOffset; 
$scope.mapInfoPanelHeight = 150; 
$scope.mapHeight = $scope.contentHeight - $scope.mapInfoPanelHeight; 
document.getElementById("side-menu").style.visibility="hidden";    

$scope.$on('$ionicView.beforeLeave', function(){
    console.log("beforeLeave");
});

$scope.$on('$ionicView.afterLeave', function(){
    console.log("afterleave"); 
    if($scope.map){
// $scope.map.setClickable(false);
// $scope.map.remove(); 
}
if($scope.watch)
    $scope.watch.clearWatch();
document.getElementById("side-menu").style.visibility="visible"; 
});


$scope.$on('$ionicView.enter', function(){
    console.log("enter"); 
    console.log("nascondo il menu"); 
    $ionicPlatform.ready(function() {
        console.log("cordova è pronto"); 

        /* mi faccio dare la posizione della macchina dal server */
//Phone.getMarkers().then(function(position){
//  console.log("== la posizione della macchina =="); 
//  console.log(JSON.stringify(position)); 

// forgio un oggetto contenente le coordinate della posizione della macchina
// per il reverse geocoding


$scope.yourLocation = null;
var posOptions = {timeout: 10000, enableHighAccuracy: true};
$cordovaGeolocation.getCurrentPosition(posOptions).then(function (position) {

    var lat  = position.coords.latitude;
    var long = position.coords.longitude;

    $scope.yourLocation = {'lat':lat,'lng':long}; 

//      $scope.latLngBounds = new plugin.google.maps.LatLngBounds(); 
//      $scope.latLngBounds.extend($scope.carPosition.position); 
//      $scope.latLngBounds.extend($scope.yourLocation); 


$scope.marker = {}; 
$scope.marker['id'] = 1; 
$scope.marker['mid'] = 1;
$scope.marker['title'] = "Io sono qui!"; 
$scope.marker['position'] = {}; 
$scope.marker['position']['lat'] =  $scope.yourLocation.lat; 
$scope.marker['position']['lng'] =  $scope.yourLocation.lng;
$scope.marker['draggable'] = true; 

$scope.marker.snippet = "tocca per le indicazioni stradali!"; 


$scope.marker.infoClick = function(ma){
    $scope.avviaNavigatore(); 
}

// forgio un oggetto marker perché la struttura dati json fornita dal webservice 
// non è adeguata per rappresentare un punto sulla mappa.

var div = document.getElementById("map_canvas");

$scope.map = plugin.google.maps.Map.getMap(div,{
    'controls': {
        'compass': true,
        'myLocationButton': true,
        'indoorPicker': true,
        'zoom': true
    },
    'gestures': {
        'scroll': true,
        'tilt': false,
        'rotate': true,
        'zoom': true
    },'camera': {
        'latLng': {"lat":45.08542235,"lng":7.70451665},
        'zoom': 11,
        'bearing': 0
    }        
});

$scope.map.on(plugin.google.maps.event.MAP_READY, function() {
    var p = new plugin.google.maps.LatLng($scope.yourLocation.lat,$scope.yourLocation.lng);
    console.log(p); 
    console.log("sposto la camera"); 

    $scope.map.moveCamera({
        "target":p,
zoom:18  //$scope.latLngBounds
});     

//      $scope.map.getCameraPosition(function(camera) {
//          console.log(camera.zoom); 
//             $scope.map.setZoom(Math.round(camera.zoom) -1); 

$scope.map.addMarker($scope.marker,function(marker){
    marker.addEventListener(plugin.google.maps.event.MARKER_DRAG_END, function(marker) {
        marker.getPosition(function(latLng) {
//marker.setTitle(latLng.toUrlValue());
//$scope.unIndirizzoLatLng = latLng; 
$scope.unIndirizzoLatLng = {'position':{'lat':latLng.lat,'lng':latLng.lng}}; 
$scope.coords = latLng.toUrlValue();
marker.showInfoWindow();
});
    });
    marker.showInfoWindow();
    $scope.visible = true; 
});     
//          }); 


$scope.map.setClickable(true);

var watchOptions = {
    frequency : 10000,
    timeout : 20000,
enableHighAccuracy: true // may cause errors if true
};

$scope.watch = $cordovaGeolocation.watchPosition(watchOptions);
$scope.watch.then(
    function(position) {
// error
$amaDialogs.showAlert("Errore",JSON.stringify(position)); 
},
function(err) {
// error
console.log("errore watchPosition"); 
$amaDialogs.showAlert("Errore","Localizzazione"); 
console.log(JSON.stringify(err));     
},
function(position) {
    var lat  = position.coords.latitude;
    var long = position.coords.longitude;
    $scope.yourLocation = {'lat':lat,'lng':long}; 
},function(err){
    $amaDialogs.showAlert("Errore","ERRORE GPS"); 
    console.log("errore GPS"); 
    console.log(err); 
}); // fine $scope.watch.then                                                       
}, 
function(err) {
    console.error('Unable to create the map', err);
    alert('Unable to create the map');
}
);  // fine $scope.map.on 

$scope.map.on(plugin.google.maps.event.MAP_CLOSE, function() {
/* console.log("Chiusura della mappa");
$scope.map.remove();
delete $scope.map; 
$scope.map = null;  */
});
//    }, function(err) {
//           // error
//           $scope.showAlert("Errore Localizzazione","Impossibile localizzare l'utente. Abilitare il servizio di localizzazione o cercare una posizione più favoevole."); 
//    });
}); 
});
});

$scope.$on('$ionicView.loaded', function(){
    console.log("loaded"); 
});


$scope.avviaNavigatore = function(){
    console.log("hai invocato avvia navigatore"); 
    console.log(JSON.stringify($scope.yourLocation));
    console.log("---------");
    console.log(JSON.stringify($scope.marker.position));
    console.log("----------");
    $scope.map.setClickable(false);

    $amaDialogs.showConfirm('Avvia Navigatore','Vuoi passare al navigatore per le indicazioni stradali?' ,function(res) {
        if(res){
            $scope.map.setClickable(true);     
            launchnavigator.navigate(
                [$scope.marker.position.lat,$scope.marker.position.lng],
                [$scope.yourLocation.lat,$scope.yourLocation.lng],
                function(){
                    console.log("Plugin success");
                },
                function(error){
                    console.log("Plugin error: "+ error);
                });
        }
        else{
            $scope.map.setClickable(true);        
        }
    },'<span class="ion-ios-checkmark-outline balanced"></span>','<span class="ion-ios-close-outline"></span>');  

}




$scope.showDisclaimer = function(){
    $scope.map.setClickable(false);

    $amaDialogs.showAlert('Posizione non affidabile',"La posizione del veicolo potrebbe non essere corretta, perché il veicolo si trova in una posizione non coperta dal segnale GPS, ad esempio all'interno di un parcheggio sotterraneo.",function(res) {
        $scope.map.setClickable(true);        
    });  

}

console.log("sono nel controller");


if(!ionic.Platform.isWebView()){
// qui gestiamo il caso di una mappa "non nativa" per web, e dispositivi particolari
console.log("mi ritiro"); 
Phone.getMarkers().then(function(position){
// forgio un oggetto marker perché la struttura dati json fornita dal webservice 
// non è adeguata per rappresentare un punto sulla mappa.

$scope.marker = {}; 
$scope.marker['id'] = 1; 
$scope.marker['mid'] = 1;
$scope.marker['title'] = "La Mia Auto"; 
$scope.marker['position'] = {}; 
$scope.marker['position']['lat'] = position.data.lat; 
$scope.marker['position']['lng'] = position.data.lon;

console.log(JSON.stringify($scope.marker));

return;  
});
}
});

/********************************************************************************************/




