'use strict';

/* 
.factory('SeqMgr', function($resource,Phone){
  return $resource(
    Phone.dataServerDebug + "sequenza-prodotti/:aziendaId/:Id",   
    {Id:"@Id",aziendaId:"@aziendaId"},
    {"update":{method:"PUT"},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    });
  })

.factory('ClientiMgr', function($resource,Phone){
  return $resource(
    Phone.dataServerDebug + "clienti/:aziendaId/:Id",   
    {Id:"@Id",aziendaId:"@aziendaId"},
    {"update":{method:"PUT"},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    });
  })
 */

/* Factories */
var slideDir = 'slide-left';

angular.module('kritaFactories', ['ionic','ngResource'])
.factory('Phone', function($q,$rootScope,$http,$resource,Session,ku,$cacheFactory){
 var factory =  {};

 var cache = $cacheFactory('kritaCache',{ capacity: 3 });


 factory.TDSettings={}; 
 factory.TDSettings['dataServer'] = "https://td-amalabs.rhcloud.com/";
 factory.TDSettings['dataServerDBG'] = "http://192.168.0.110:8080/";


 var areProdottiFiltered = false; 
 var items = {"cliente":undefined,"prodotti":{}};  
 var clienteAttivo = undefined; 
 var emulated = window.tinyHippos != undefined;
var filtri = {esistenza:true}; 

 factory.dataServer = "https://krita-amares.rhcloud.com/";
//factory.dataServer = "http://192.168.1.176:8888/";

factory.dataServerDebug =  "https://krita-amares.rhcloud.com/";
//factory.dataServerDebug = "http://192.168.0.43:8888/"; 
//factory.dataServer = "http://192.168.0.43:8888/"; 



var currentUser = undefined; 


var sidebar;



/******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
******************************************************************
/




/*******************************************************************************/
/*                                                                             */
/*                                                                             */
/*                                                                             */
/*******************************************************************************/
  factory.getMarkers = function(azienda){
     console.log("factory.getMarkersEmuByAzienda(" + azienda + ")");
     var res = $resource(factory.TDSettings['dataServer'] + '/lastPosition/', {},
        {get: 
            {
                cache: true,
                method: 'GET'
            }
        }); 
     return res.get().$promise; 
 }
/*******************************************************************************/



/******************************************************************
* Wrapper che consente di caricare le categorie indipendentemente dal
* dispositivo utilizzato. 
*
* restituisce un promise in tutti i casi
*
******************************************************************/
    
  factory.getDocumenti = function(user){
    console.log("factory.getDocumenti %s",user);
    var res = $resource(factory.TDSettings['dataServer'] + 'documents', {},
        {get: 
            {
                cache: true,
                method: 'GET'
            }
        }); 
    return res.get().$promise; 
  }

/******************************************************************/

factory.dataOdierna = function(){
  var data = new Date(); 
  var giorno = data.getDate(); // il giorno 
  var mese = data.getMonth() + 1; // il mese è zero based. 
  var anno = data.getFullYear(); 
  return  giorno + "-" +  mese + "-" + anno; 
}   
     
factory.base64ArrayBuffer = function(arrayBuffer) {
  var base64    = ''
  var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'

  var bytes         = new Uint8Array(arrayBuffer)
  var byteLength    = bytes.byteLength
  var byteRemainder = byteLength % 3
  var mainLength    = byteLength - byteRemainder

  var a, b, c, d
  var chunk

  // Main loop deals with bytes in chunks of 3
  for (var i = 0; i < mainLength; i = i + 3) {
    // Combine the three bytes into a single integer
    chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2]

    // Use bitmasks to extract 6-bit segments from the triplet
    a = (chunk & 16515072) >> 18 // 16515072 = (2^6 - 1) << 18
    b = (chunk & 258048)   >> 12 // 258048   = (2^6 - 1) << 12
    c = (chunk & 4032)     >>  6 // 4032     = (2^6 - 1) << 6
    d = chunk & 63               // 63       = 2^6 - 1

    // Convert the raw binary segments to the appropriate ASCII encoding
    base64 += encodings[a] + encodings[b] + encodings[c] + encodings[d]
  }

  // Deal with the remaining bytes and padding
  if (byteRemainder == 1) {
    chunk = bytes[mainLength]

    a = (chunk & 252) >> 2 // 252 = (2^6 - 1) << 2

    // Set the 4 least significant bits to zero
    b = (chunk & 3)   << 4 // 3   = 2^2 - 1

    base64 += encodings[a] + encodings[b] + '=='
  } else if (byteRemainder == 2) {
    chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1]

    a = (chunk & 64512) >> 10 // 64512 = (2^6 - 1) << 10
    b = (chunk & 1008)  >>  4 // 1008  = (2^6 - 1) << 4

    // Set the 2 least significant bits to zero
    c = (chunk & 15)    <<  2 // 15    = 2^4 - 1

    base64 += encodings[a] + encodings[b] + encodings[c] + '='
  }

  return base64
}     

return factory; 
})

.factory('GarageVirtuale', function($resource,Phone){
  var base = Phone.TDSettings.dataServer; 
  return $resource(
    base + "sensor/virtualGarage",   
    {token:"@token"},
    {"info":{method:"GET",url:base + "sensor/lastTrigger/speed"},
    "attiva":{method:"POST"},
    "reset":{method:"POST",url:base + 'sensor/virtualGarage/reset'},
    }
  );
})

.factory('crash', function($resource,Phone){
  return $resource(
    Phone.TDSettings.dataServer + "sensor/virtualGarage",   
    {token:"@token"},
    {"info":{method:"GET"},
    "attiva":{method:"POST"},
    "reset":{method:"POST",url:Phone.TDSettings.dataServer + 'sensor/virtualGarage/reset'},
     //"reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    }
  );
})

.factory('speed', function($resource,Phone){
  return $resource(
    Phone.TDSettings.dataServer + "sensor/virtualGarage",   
    {Id:"@Id",token:"@token"},
    {"update":{method:"PUT"},
    "attiva":{method:"POST"},
    "reset":{method:"POST",url:Phone.TDSettings.dataServer + 'sensor/virtualGarage/reset'},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    }
  );
})


.factory('ku', function(Session,$cordovaSQLite,$ionicPlatform){
  var ku =  {};
  var db = null;
  
/*  $ionicPlatform.ready(function(){
    db = $cordovaSQLite.openDB("NoCloud/krita-sqlite.db");
    $cordovaSQLite.execute(db,"CREATE TABLE IF NOT EXISTS filemeta (id text primary key, data text,hash text)");
  });
  */
  

  

ku.mobilecheck = function() {
   // if(typeof(PhoneGap)=='undefined') return false;
   //      else return true; 
  var isCordovaApp = !!window.cordova;
      if(isCordovaApp) return true; else return false; 

 }

    /***
     questo set di funzioni controlla l'esistenza di un file
     
    */
ku.checkIfFileExists=function(path,onExists,onNotExists){
  
  ku.getDataDirectory(function(dataDirectory){
      console.log("controllo se il file " +  dataDirectory +path + " esiste"); 
      window.resolveLocalFileSystemURL(dataDirectory + path,onExists,onNotExists); //onExists,onNotExists); 

  });
}

ku.gFileSystem = null; 

/* portiamo ordine nelle operazioni su file con questa sorta di classe che incorpora tutte le 
   principali operazioni su file */

// Impostiamo la variabile globale gFileSystem
 ku.gotFS = function(fileSystem) {
      ku.gFileSystem = fileSystem;
 };
// pickup the URI from the Camera edit and assign it to the global var gImageURI
// create a filesystem object called a 'file entry' based on the image URI
// pass that file entry over to gotImageURI()
ku.updateCameraImages = function(imageURI) {
        gImageURI = imageURI;
        window.resolveLocalFileSystemURL(imageURI, FileIO.gotImageURI, FileIO.errorHandler);
};


  //window.requestFileSystem(window.TEMPORARY, 1024*1024, onInitFs, errorHandler);
  //window.resolveLocalFileSystemURL($scope.sPath + elemento.file,skipTransfer,performTransfer); 
  //window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSytemSuccessMobile, function(error) {console.log("errore " + JSON.stringify(error));});
/* salva i metadati del file associato a fileEntry nel file corrispondente a 
   fileEntry.name + "md" 
*/

        ku.persistMeta =  function(elemento){
        var query = "INSERT OR REPLACE INTO filemeta (id,data,hash) VALUES (?,?,?)";
        $cordovaSQLite.execute(db,query,[elemento.file,JSON.stringify(elemento),elemento.chk]).then(function(res){
                                                             console.log(res);
                                                             },
                                                             function(err){
                                                             console.error(err);
                                                             });
        
        }
        
        
ku.saveMeta = function(fileEntry,elemento){
// ottengo la cartella padre di fileEntry
fileEntry.getParent(function(dirEntry){
  // se non esiste creo il file dei metadati
  dirEntry.getFile(fileEntry.name + ".md", {create: true}, function(fileMDEntry) {
      // Create a FileWriter object for our FileEntry
      fileMDEntry.createWriter(function(fileWriter) {

        fileWriter.onwriteend = function(e) {
         // console.log('Write completed.');
        };

        fileWriter.onerror = function(e) {
          console.log('Write failed: ' + e.toString());
        };

        fileWriter.write(JSON.stringify(elemento));        

      }, ku.errorHandler);

    }, ku.errorHandler);
  }); // getParent fine
}

ku._canBeUpgraded = function(fileEntry,remoteMeta,onEnd){
  console.log("_canBeUpgraded %s",remoteMeta.file); 
  var query = "SELECT id,data,hash FROM filemeta WHERE id = '?'";
  $cordovaSQLite.execute(db,query,[remoteMeta.file]).then(function(res){
    console.log("query eseguita"); 
    if(res.rows.length > 0){
        console.log("riga %s trovata",remoteMeta.file); 
       //console.log("SELECTED -> " + res.rows.item(0).id + " " + res.rows.item(0).data + " " + res.rows.item(0).hash);
       var meta = JSON.parse(res.rows.item(0).data);
       var procedi = false;
      
      // se è definita la data di modifica e se questa data è diversa da quella scaricata la volta precedente allora procedi con l'aggiornamento             
       if(remoteMeta.mtime!=undefined && meta.mtime!=undefined){ 
         if(meta.mtime != remoteMeta.mtime) procedi = true;
       }
      
      // se la dimensione del file è definita ed è diversa dalla dimensione del file scaricato in precedenza allora procedi con l'aggiornamento             
      /* if(remoteMeta.bytes!=undefined){
         if(fileDati.size!=remoteMeta.bytes) procedi = true;
       }*/
      
      // se è definito il campo di controllo se questo campo è diverso da quello del file scaricato precedentemnte allora procedi con l'aggiornamento             
       if(remoteMeta.chk!=undefined && meta.chk!=undefined){
         if(meta.chk!=remoteMeta.chk) procedi = true;
       }
                 
       if(procedi == true){
        onEnd(true);
       }else{
        onEnd(false);
       }
  }else{
    console.log("riga NON trovata");
    onEnd(true); 
  }
},function(err){console.log("Errore query?"); console.log(err);onEnd(true)}); // fine della query

        
        
/*        fileEntry.getParent(function(dirEntry){
                            dirEntry.getFile(fileEntry.name + ".dl.md", {},
                                             function(fileMDEntry) {
                                             fileMDEntry.file(function(file) {
                                                              var reader = new FileReader();
                                                              reader.onloadend =canBeUpgradedOnReadEnd;
                                                              reader.readAsText(file);
                                                              });
                                             }, function(error){ // in caso di file metadati non esistente procedi e scarica.
                                             onEnd(true); 
                                             }); // fine getFile
                            }); // getParent fine
*/
        }

        
ku.canBeUpgraded = function(fileEntry,remoteMeta,onEnd){

        var canBeUpgradedOnReadEnd = function(evt){
    
        fileEntry.file(function(fileDati){
                       var meta = JSON.parse(evt.target.result);
                       var procedi = false;
                       
                       if(remoteMeta.mtime!=undefined){
                       // se è definita la data di modifica
                       // e se questa data è diversa da quella scaricata la volta precedente
                       // allora procedi con l'aggiornamento
                       if(meta.mtime != remoteMeta.mtime) procedi = true;
                       }
                       
                       if(remoteMeta.bytes!=undefined){
                       // se la dimensione del file è definita
                       // ed è diversa dalla dimensione del file scaricato in precedenza
                       // allora procedi con l'aggiornamento
                       if(fileDati.size!=remoteMeta.bytes) procedi = true;
                       }
                       
                       if(remoteMeta.chk!=undefined){
                       // se è definito il campo di controllo
                       // se questo campo è diverso da quello del file scaricato precedentemnte
                       // allora procedi con l'aggiornamento
                       if(meta.chk!=remoteMeta.chk) procedi = true;
                       }
                       
                       if(procedi == true){
                       console.log("meta.chk:%s, remoteMeta.chk:%s, meta.mtime: %s, remoteMeta.mtime: %s, fd.size:%s, remoteMeta.bytes:%s",
                                   meta.chk,
                                   remoteMeta.chk,
                                   meta.mtime,
                                   remoteMeta.mtime,
                                   fileDati.size,
                                   remoteMeta.bytes
                                   );
                       console.log("$$$$$$$$$$$$$");
                       console.log(remoteMeta);
                       console.log("$$$$$$$$$$$$$");
                       onEnd(true);
                       }else{
                       onEnd(false);
                       }
                       }); // onReadEnd
        };

        
 fileEntry.getParent(function(dirEntry){
  dirEntry.getFile(fileEntry.name + ".dl.md", {},
                   function(fileMDEntry) {
                    fileMDEntry.file(function(file) {
                                     var reader = new FileReader();
                                     reader.onloadend =canBeUpgradedOnReadEnd;
                                     reader.readAsText(file);
                                     });
                    }, function(error){ // in caso di file metadati non esistente procedi e scarica.
    onEnd(true); 
  }); // fine getFile
 }); // getParent fine
}

ku.move = function(srcImageURI,dstImageURI,sPath) {
  //  console.log("move: %s --> %s",srcImageURI,dstImageURI); 
  // ku.dstImageURI =  dstImageURI; 
  window.resolveLocalFileSystemURL(sPath + dstImageURI,function(fileEntry){
      fileEntry.remove(function(fileEntry){
        // se la rimozione del file ha avuto esito positivo
    	    // invoco la funzione che rinomina l'altro file
        window.resolveLocalFileSystemURL(srcImageURI,ku.moveFile,ku.errorHandler);  
      },
      function(fileEntry){console.log("errore rimuovendo il file %s",fileEntry.name);}
      ); //ku.errorHandler);
  },function(error){
     // console.log("errore resolve %s ", JSON.stringify(error));
      window.resolveLocalFileSystemURL(srcImageURI,ku.moveFile,ku.errorHandler);
  }); //ku.errorHandler); 
};

ku.moveFile = function(fileEntry) {
  var newName = fileEntry.name.replace(".dl","").toString(); 
     fileEntry.getParent(function(dirEntry){
        fileEntry.moveTo(dirEntry, newName, ku.movedImageSuccess, ku.errorHandler);
     },
     function(error){
      console.log("impossibile risalire al parent di %s - %s",fileEntry.name, error);
     })
};
 
// pickup the file entry, rename it, and move the file to the app's root directory.
// on success run the movedImageSuccess() method
ku.gotImageURI = function(fileEntry) {
     var newName = "thumbnail_" + gCurrentFlo + ".jpg";
     fileEntry.moveTo(gFileSystem.root, newName, ku.movedImageSuccess, ku.errorHandler);
};
 
// send the full URI of the moved image to the updateImageSrc() method which does some DOM manipulation
ku.movedImageSuccess = function(fileEntry) {
};
 
// ottiene una nuova istanza di "fileEntry" e la passa a removeFile per la cancellazione del file.
//removeDeletedImage : function(imageURI){
ku.remove = function(imageURI){  
    window.resolveLocalFileSystemURL(imageURI, ku.removeFile, ku.errorHandler);
};
 
// cancella un file
ku.removeFile = function(fileEntry){
    fileEntry.remove();
};

// gestore errori di accesso ai file
ku.errorHandler = function(e) {
     var msg = '';
     switch (e.code) {
     case FileError.QUOTA_EXCEEDED_ERR:
             msg = 'QUOTA_EXCEEDED_ERR';
             break;
      case FileError.NOT_FOUND_ERR:
             msg = 'NOT_FOUND_ERR';
             break;
      case FileError.SECURITY_ERR:
             msg = 'SECURITY_ERR';
             break;
      case FileError.INVALID_MODIFICATION_ERR:
             msg = 'INVALID_MODIFICATION_ERR';
             break;
      case FileError.INVALID_STATE_ERR:
             msg = 'INVALID_STATE_ERR';
             break;
      default:
             msg = e.code;
      break;
};
console.log('Error: ' + msg);
};

ku.getImgPath = function(onRequestCompleted){
    var emulated = window.tinyHippos != undefined;
      if ( emulated || !ku.mobilecheck() ){
        onRequestCompleted(Session.azienda.impostazioni.cdnStorage);
  }else
  if(ionic.Platform.isAndroid()){
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
                               console.log(fileSystem.root.nativeURL);
                               Session.azienda.impostazioni.imgPathAndroid = fileSystem.root.nativeURL + "/" + Session.azienda.id + Session.azienda.anno;
                               onRequestCompleted(fileSystem.root.nativeURL+ "/" + Session.azienda.id + Session.azienda.anno + "/");  
                               }, function(){console.log("OOps problema richiedendo il path di sistema")}); 
      }
    else
        if(cordova.file.dataDirectory)
        return onRequestCompleted(cordova.file.dataDirectory + Session.azienda.id + Session.azienda.anno + "/");
            else
        return onRequestCompleted(Session.azienda.impostazioni.imgPath + Session.azienda.anno + "/");
  }

ku.getDataDirectory = function(onEnd){
   var emulated = window.tinyHippos != undefined;
   if ( emulated || !ku.mobilecheck()){
    console.log("ku.getDataDirectory: la funzione è stata invocata da un ambiente browser"); 
    onEnd(""); 
    return; 
   }
   else
   {
    console.log("ku.getDataDirectory: la funzione è stata invocata da un ambiente device"); 
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, function(fileSystem){
      console.log("nativeURL:" + fileSystem.root.nativeURL);
      console.log("dataDirectory:" + cordova.file.dataDirectory);
      console.log("file:" + cordova.file);
      if(cordova.file.dataDirectory)
    if(ionic.Platform.isAndroid()){
          onEnd(fileSystem.root.nativeURL);// onEnd("file:///storage/emulated/legacy/");
  }
  else 
  onEnd(cordova.file.dataDirectory); 
       else
       onEnd(fileSystem.root.nativeURL);
    },
    function(evt){
      console.log("ku.getDataDirectory: errore in window.requestFileSystem"); 
      console.log(evt.target.error.code);
      console.log(JSON.stringify(evt.target.error)); 
    }); 
  }
}

ku.readFile = function(filename, onloadend){
  var fileObject;
  console.log("leggo il file:" + filename);
  
  function fail(error){
    console.log("fail"); 
    console.log("errore " + error.code); 
    onloadend(); 
  }  
  
  function onFileSystemSuccess(fileSystem) {
    ku.getDataDirectory(function(dataDirectory){
      console.log("onFileSystemSuccess" + dataDirectory + filename);
      window.resolveLocalFileSystemURL(dataDirectory + filename,function(fe){
        fe.file(function(file) {
          var reader = new FileReader();
          reader.onloadend = onloadend; 
          reader.readAsText(file);
       }); 
      }); 
    });
  }


    if(typeof LocalFileSystem != 'undefined'){
        console.log("localfilesystem");
        window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, onFileSystemSuccess, fail);
    }
    else{
        console.log("webkit localfilesystem");
        window.webkitRequestFileSystem(window.TEMPORARY,0,onFileSystemSuccess, fail);
    }
  }
   
   return ku; 
 })

.factory('Booking', function($resource,Phone){
  return $resource(
    Phone.dataServerDebug + "ordini/:aziendaId/:Id",   
    {Id:"@Id",aziendaId:"@aziendaId"},
    {"update":{method:"PUT"},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    }
  );
})

.factory('SeqMgr', function($resource,Phone){
  return $resource(
    Phone.dataServerDebug + "sequenza-prodotti/:aziendaId/:Id",   
    {Id:"@Id",aziendaId:"@aziendaId"},
    {"update":{method:"PUT"},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    });
  })

.factory('ClientiMgr', function($resource,Phone){
  return $resource(
    Phone.dataServerDebug + "clienti/:aziendaId/:Id",   
    {Id:"@Id",aziendaId:"@aziendaId"},
    {"update":{method:"PUT"},
     "reviews":{'method':'GET','params':{'reviews_only':"true"}, isArray: true}
    });
  })



.factory('AuthService', function ($http,$resource,$q, Session,ku,Phone) {
  var authService = {};
  var Azienda = {}; 

  /*authService.sortByInnova = function(product){
    return product.listino1; 
  }
  */

  authService.filterByInnova = function(prodotto) {
  if((prodotto.esistenza >= prodotto.pzConf && prodotto.esistenza > 0 )  ||  (prodotto.giornoConsegna && prodotto.meseConsegna  && prodotto.annoConsegna)) return true; else return false;
  }


 authService.filterByMSS = function(prodotto) {
  if(prodotto.esistenza > 0 ) return true; else return false;
  }

  authService.filterByPRK = function(prodotto,listino) {
  if(prodotto.listino[listino]) return true; else return false;
  }

  authService.esistenzaMSS = function(prodotto){
    if(prodotto.esistenza < 100)
      return prodotto.esistenza; 
    else 
      return 100; 
  }

  authService.esistenzaPRK = function(prodotto){
    return prodotto.esistenza; 
  }
  authService.esistenzaInnova = function(prodotto){
    return prodotto.esistenza; 

  }


  authService.scontoMSS = function(prodotto){
    if(items.cliente.prezzi[prodotto.codiceArticolo]){
      console.log("lo sconto particolare è definito"); 
    }
    else
      console.log("sconto particolare non definito"); 
    if(prodotto.esistenza < 100)
      return prodotto.esistenza; 
    else 
      return 100; 
  }




/******************************************************************************************
* calcola il prezzo praticato e lo restituisce. il prezzo viene scelto fra quello di listino
* e quello praticato precedentemente. 
*
****************************************************************************************/
authService.calcolaPrezzoPraticatoInnova = function(prodotto,prezzi,cliente){
  var prezzoPraticato; 
  if(prodotto.prezzoPraticato) return prodotto.prezzoPraticato; 
  
  if(!prodotto.prezzoPraticato){
  // se il prezzo praticato non è mai stato stabilito. 
  prezzoPraticato = prodotto.listino[cliente.NGB_LIS];

  if(prezzi){
    if(prezzi[prodotto.codiceArticolo]) // questo articolo ha un prezzo praticato 
      prezzoPraticato = parseInt(prezzi[prodotto.codiceArticolo].prezzo)/10000;
    }
  }else
  return prodotto.prezzoPraticato; 
  
  return prezzoPraticato; 
}
/*----------------------------------------------------------------------------------------*/


/******************************************************************************************
* calcola il prezzo praticato e lo restituisce. il prezzo viene scelto fra quello di listino
* e quello praticato precedentemente. 
*
****************************************************************************************/
authService.calcolaPrezzoPraticatoPratiko = function(prodotto,prezzi,cliente){
  console.log(prodotto); 
  console.log(prezzi); 
  console.log(cliente.sconto); 
  var prezzoPraticato = prodotto.listino[cliente.NGB_LIS] / ((prodotto.aliquotaIva+100)/100);
  prezzoPraticato = Phone.applicaSconto(prezzoPraticato,cliente.sconto);
  return prezzoPraticato; 
}
/*----------------------------------------------------------------------------------------*/


/******************************************************************************************
* calcola il prezzo praticato e lo restituisce. il prezzo viene scelto fra quello di listino
* e quello praticato precedentemente. 
*
****************************************************************************************/
authService.calcolaPrezzoPraticatoMSS = function(prodotto,prezzi,cliente){
  var prezzoPraticato = prodotto.listino[cliente.NGB_LIS];
  var sconto = 0; 
  if(prodotto.sconto)
      sconto = prodotto.sconto; 
  else
    sconto = cliente.sconto; 

  console.log("calcPrzPraticatoMSS - prodotto:%s, prezzi:%s, sconto:%s",prodotto,prezzi,sconto); 

  prezzoPraticato = Phone.applicaSconto(prezzoPraticato,sconto);
  return prezzoPraticato; 
}
/*----------------------------------------------------------------------------------------*/


  var aziende = {
    "innova":{
    "id":"innova",
    "nome": "Innova s.r.l.", 
    "anno":"2014",
      "NGB_LIS":"1",
    "cachepath":'data/cache/',
    "sortBy":authService.sortByInnova,
    "filterBy":authService.filterByInnova,
    "calcolaPrezzoPraticato":authService.calcolaPrezzoPraticatoInnova,
    "esistenza":authService.esistenzaInnova,
    "sconto":authService.scontoInnova,
    "perms":{
      "openCHSCODlg":false,
      "chgprice":true,
      "elcli":true,
      "elcat":true,
      "sinc":true,
      "ordcor":true,
      "gesord":true,
      "mapcli":true,
      "elrep":true,
      "camazi":true,
      "filpro":true,
      "vis1":true,
      "vis2":true,
      "vis4":true      
    },   
    "nf":4, 
    "impostazioni":{
      "imgPath":"../../Documents/innova",
      "imgPathAndroid":"file:///data/data/com.ama_research.krita/innova",
      "homeaddr":Phone.dataServer,
      "cdnStorage":"https://dl.dropboxusercontent.com/u/24837261/innova/INNOVA/Img_Articoli/001/",
      "skipsc":"true",
      "defaultView":1
    },"agente":"415.00004"
  },
    "pratiko":{
    "id":"pratiko",
    "nome": "Pratiko Life s.r.l.", 
    "anno":"2014",
      "NGB_LIS":"5",
    "cachepath":'', 
    "filterBy":authService.filterByPRK,
    "calcolaPrezzoPraticato":authService.calcolaPrezzoPraticatoPratiko,    
    "esistenza":authService.esistenzaPRK,
      "nf":2,     
    "perms":{
      "openCHSCODlg":false,
      "prodsim":false,
      "elcat":true,
      "elcli":true,
      "sinc":true,
      "ordcor":true,
      "gesord":true,
      "mapcli":true,
      "camazi":true,
      "ordpers":true,
      "espcli":true,
      "filpro":false, 
      "elrep":false,
      "vis1":true,
      "vis2":true,
      "vis4":false      
    },
    "impostazioni":{
      "imgPath":"../../Documents/pratiko",
      "imgPathAndroid":"file:///data/data/com.ama_research.krita/pratiko",
      "homeaddr":Phone.dataServer,
      "cdnStorage":"https://dl.dropboxusercontent.com/u/24837261/pratiko/PRATIKOLIFE-AMARESEARCH/", //https://dl.dropboxusercontent.com/u/230141682/
      "skipsc":"false",
      "defaultView":1
    },"agente":"415.00004"
  },
    "mss":{
    "id":"mss",
    "nome": "Mario Schiano s.r.l.", 
    "anno":"2014",
      "NGB_LIS":"5",
      "cachepath":'',
      "filterBy":authService.filterByMSS,      
      "calcolaPrezzoPraticato":authService.calcolaPrezzoPraticatoMSS,
      "esistenza":authService.esistenzaMSS,         
      "sconto":authService.scontoMSS,
        "nf":2,      
      "perms":{
      "openCHSCODlg":true,
      "elcli":true,
      "elcat":true,
      "sinc":true,
      "ordcor":true,
      "espcli":true,      
      "gesord":true,
      "mapcli":true,
      "camazi":true,
      "filpro":true,
      "vis1":true,
      "vis2":true,
      "vis4":true
    },            
    "impostazioni":{
      "imgPath":"../../Documents/mss",
      "imgPathAndroid":"file:///data/data/com.ama_research.krita/mss",
      "homeaddr":Phone.dataServer,
      "cdnStorage":"https://dl.dropboxusercontent.com/u/24837261/mss/prodotti/",
      "skipsc":"true",
      "defaultView":1
    },"agente":"415.00004"
  },
    "AMR2014":{
    "id":"AMR2014",
    "nome": "AMR2014", 
    "anno":"2014",
      "NGB_LIS":"5",
        "nf":2,
    "perms":{
      "openCHSCODlg":false
    },      
    "impostazioni":{
      "imgPath":"../../Documents/AMR2014",
      "homeaddr":Phone.dataServer,
      "cdnStorage":"https://dl.dropboxusercontent.com/u/AMR2014/",
      "skipsc":"false"
    },"agente":"415.00004"
  },
    "SCN2014":{
    "id":"SCN2014",
    "nome": "SCN2014", 
    "anno":"2014",
      "NGB_LIS":"5",
        "nf":2,
    "perms":{
      "openCHSCODlg":true
    },      
    "impostazioni":{
      "imgPath":"../../Documents/SCN2014",
      "homeaddr":Phone.dataServer,
      "cdnStorage":"https://dl.dropboxusercontent.com/u/SCN2014/",
      "skipsc":"false"
    },"agente":"415.00004"
  },
    "demo":{
    "id":"demo",
    "nome": "demo", 
    "anno":"2014",
      "nf":2,
      "NGB_LIS":"5",
    "impostazioni":{
      "imgPath":"../../Documents/demo",
      "homeaddr":Phone.dataServer,
      "cdnStorage":Phone.dataServer + "demo/",
  "imgPathAndroid":"file:///data/data/com.ama_research.krita/demo",
      "skipsc":"false"
    },"agente":"415.000010"
  }
  };



authService.isAuthorized = function(action){
  return Session.azienda.perms[action]; 
}

authService.getAzienda = function(){
  console.log("getAzienda()");
  return Azienda; 
}

authService.getAziendaById = function(id){
  return aziende[id]; 
}

authService.setAzienda = function(azienda){
  Azienda = azienda; 
}

authService.setAziendaById = function(aziendaId){
  Azienda = aziende[id]; 
}


authService.loginOL = function (credentials) {
  return $http
  .post('/login', credentials)
  .then(function (res) {
    Session.create(res.id, res.user.id, res.user.role);
    return res.user;
  });
};

/******************************************************************
* Wrapper che consente di caricare gli utenti di una data azienda
*
* restituisce un promise in tutti i casi
*
******************************************************************/
authService.getUtentiW = function(aziendaId){
        console.log("richiesta utenti via rete %s",JSON.stringify(aziendaId));
        return authService.getUtentiByAziendaN(aziendaId);
    
}
/******************************************************************/
    
  authService.getUtentiByAziendaN = function(aziendaId){
    var azienda = authService.getAziendaById(aziendaId); 
    console.log("factory.getUtentiByAziendaN:" + azienda.id);
    var res = $resource(azienda.impostazioni.homeaddr + azienda.id+'/s/users.json'); 
    return res.get().$promise; 
  }

  authService.sha1 = function(plain){
    return plain; 
  }


authService.login = function (credentials,onLoginSuccess,onLoginError) {
  console.log("login **************"); 
  console.log(JSON.stringify(credentials)); 

//authService.getUtentiW(credentials.azienda).then(function(result){
    var systemUser = {
        "nome": "Sys",
        "cognome": "User",
        "ragioneSociale": "",
        "piva": "N",
        "username": "adm",
        "pwd": "adm",
        "ruolo": {
            "id": "0",
            "name": "administrator",
            "ces": "415.00001"
                 }
        };

                                                 
  //  authService.users = result;
   authService.users = {};                                                
   authService.users['adm'] = systemUser;
   authService.users['usr'] = systemUser;
    //var azienda = authService.getAziendaById(credentials.azienda); 

   // console.log("factory.getDocumenti %s",user);

    var res = $resource(Phone.TDSettings['dataServer'] + 'oauth/token', 
      {targa:"@targa",password:"@password",client_id:"@client_id",client_secret:"@client_secret",grant_type:"@grant_type"},
      {
        get:{cache: true,method: 'GET'}
      }
    ); 

    //return res.get().$promise; 

    res.get({targa:credentials.username,password:credentials.password,client_id:"fca-client",client_secret:"fca-client-secret",grant_type:"password"},
      function(res){
        if(res.value){
          console.log("ok hai avuto accesso"); 
          Session.create(res,res); // aggiustare togliendo il secondo parametro
          console.log("il token è "); 
          console.log(Session.token); 
          console.log(Session.isExpired()); 
          onLoginSuccess(res); 
          }
        else{
          console.log("accesso negato"); 
          Session.destroy(); 
          onLoginError(); 
        }
      }); 

/*
    var u = authService.users[credentials.username];
    console.log(u); 
    if(u) // se l'utente esiste nel database
    {
      if(u.pwd==authService.sha1(credentials.password)){
        console.log("password ok"); 
        var t = {'token':"1234568"}; 
        Session.create(t,u);
      //  u.aziendaId = credentials.azienda; 
        onLoginSuccess(u); 
      }
      else{
        Session.destroy(); 
        console.log("password errata"); 
        onLoginError(); 
      }
    }else{
      Session.destroy(); 
      console.log("utente non esistente"); 
      onLoginError(); 
    }
 // }); 
*/
};

authService.isAuthenticated = function () {
    return !!Session.userId;
  };
 
 /* authService.isAuthorized = function (authorizedRoles) {
    if (!angular.isArray(authorizedRoles)) {
      authorizedRoles = [authorizedRoles];
    }
    return (authService.isAuthenticated() &&
      authorizedRoles.indexOf(Session.userRole) !== -1);
  };
*/
         
  authService.logOff = function(){
        factory.currentUser = undefined; 
        console.log(factory.currentUser); 
  };

  return authService;
})

.constant('AUTH_EVENTS', {
  loginSuccess: 'auth-login-success',
  loginFailed: 'auth-login-failed',
  logoutSuccess: 'auth-logout-success',
  sessionTimeout: 'auth-session-timeout',
  notAuthenticated: 'auth-not-authenticated',
  notAuthorized: 'auth-not-authorized'
}); 
  



/*
.factory('CacheService', function ($cacheFactory) {
  var authService = {};

  authService.setAziendaById = function(aziendaId){
    Azienda = aziende[id]; 
  }

  return authService;
})


*/










